import 'dart:async';
import 'package:flutter/services.dart';

class PendoFlutterPlugin {
  static const MethodChannel _channel =
  const MethodChannel('pendo_flutter_plugin');

  static void initSDK(
      String appKey, dynamic initParams) async {
    dynamic arguments = {
      "ApplicationKey": appKey,
      "ApplicationParamaters": initParams
    };
    await _channel.invokeMethod('initSDK', arguments);
  }

  static void clearVisitor() async {
    await _channel.invokeMethod('clearVisitor');
  }

  static void switchVisitor(String visitorId, String accountId, dynamic visitorData, dynamic accountData) async {
    dynamic arguments = {
      "VisitorIDKey": visitorId,
      "AccountIDKey": accountId,
      "VisitorDataKey": visitorData,
      "AccountDataKey": accountData
    };
    await _channel.invokeMethod('switchVisitor', arguments);
  }

  static void setVisitorData(dynamic visitorData) async {
    dynamic arguments = {
      "VisitorDataKey": visitorData
    };
    await _channel.invokeMethod('setVisitorData', arguments);
  }

  static void setAccountData(dynamic accountData) async {
    dynamic arguments = {
      "AccountDataKey": accountData
    };
    await _channel.invokeMethod('setAccountData', arguments);
  }

  static void trackEventWithProperties(String event, dynamic properties) async {
    dynamic arguments = {
      "EventNameKey": event,
      "EventPropertiesKey": properties
    };
    await _channel.invokeMethod('trackEventWithProperties', arguments);
  }
}
